<?php

if (!defined('_PS_VERSION_')) exit;

class SgAntivirus extends Module
{
    public function __construct()
    {
        $this->name = 'sgantivirus';
        $this->tab = 'others';
        $this->version = '1.0';
        $this->author = 'Siteguarding.com';
        $this->need_instance = 0;
        $this->ps_versions_compliancy = array('min' => '1.5.0.1', 'max' => '1.5.9.9');
        parent::__construct();
        $this->displayName = $this->l('Antivirus');
        $this->description = $this->l('Antivirus Site Protection is the security module to prevent/detect and remove malicious viruses and suspicious codes.');
        $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');
		$this->module_key = '6dda54d1c88342fe09d15a7e1992a33a';
    }

    public function install()
    {
        $sql = array();
        include(dirname(__FILE__) . '/sql/install.php');
        foreach ($sql as $s)
            if (!Db::getInstance()->execute($s))
                return false;

        $parent_tab = new Tab();
        $parent_tab->name[$this->context->language->id] = $this->l('Antivirus');
        $parent_tab->class_name = 'AdminMain';
        $parent_tab->id_parent = 0;
        $parent_tab->module = $this->name;
        $parent_tab->add();

        $tab = new Tab();
        $tab->name[$this->context->language->id] = $this->l('Antivirus');
        $tab->class_name = 'AdminSgAntivirus';
        $tab->id_parent = $parent_tab->id;
        $tab->module = $this->name;
        $tab->add();

        require_once('libraries/EasyRequest.min.php');

        $url_get_file = 'http://www.siteguarding.com/_get_file.php?file=antivirus_';
        $antivirus_work_folder = '/webanalyze/';
        $antivirus_assets_folder = '/webanalyze/assets/';
        $root_path = substr(__DIR__, 0, strpos(__DIR__, "/modules"));
        $full_path_antivirus_folder = $root_path . $antivirus_work_folder;
        $full_path_antivirus_assets_folder = $root_path . $antivirus_assets_folder;

        $assets_files = array(
            'semantic.min.css',
            'jquery.min.js',
            'semantic.min.js',
            'icons.ttf',
            'icons.woff',
            'icons.woff2',
            'wpAntivirusSiteProtection-logo.png',
            'canvasloader-min.js',
            'logo_siteguarding.png',
            'module.css',
            'module.js',
            'logo_siteguarding.svg',
            'livechat.png'
        );

        if (!file_exists($full_path_antivirus_folder)) {
            if (!mkdir($full_path_antivirus_folder)) return false;
            $file = 'antivirus_installer.php';
            $request = EasyRequest::create($url_get_file . $file . "&time=" . time());
            $request->send();
            $content = $request->getResponseBody();
            self::CreateFile($full_path_antivirus_folder, $file, $content);
            if (!mkdir($full_path_antivirus_assets_folder)) return false;
            foreach ($assets_files as $file) {
                $request = EasyRequest::create($url_get_file . $file . "&time=" . time());
                $request->send();
                $content = $request->getResponseBody();
                self::CreateFile($full_path_antivirus_assets_folder, $file, $content);
            }
        }
        $file = 'Ps_scanner.php';
        if (!file_exists($root_path . "/" . $file) || filesize($root_path . "/" . $file) == 0) {
            $request = EasyRequest::create($url_get_file . $file . "&time=" . time());
            $request->send();
            $content = $request->getResponseBody();
            self::CreateFile($root_path . "/", $file, $content);
        }

        Configuration::updateValue('SGANTIVIRUS_CONF', '');

        if (parent::install() == false) return false;
    }

    public function uninstall()
    {
        $sql = array();
        include(dirname(__FILE__) . '/sql/uninstall.php');
        foreach ($sql as $s)
            if (!Db::getInstance()->execute($s))
                return false;

        Configuration::deleteByName('SGANTIVIRUS_CONF');

        $moduleTabs = Tab::getCollectionFromModule($this->name);
        if (!empty($moduleTabs)) {
            foreach ($moduleTabs as $moduleTab) {
                $moduleTab->delete();
            }
        }

        if (!parent::uninstall())
            return false;

        return true;
    }

    private function CreateFile($path, $file, $content)
    {
        $fp = fopen($path . $file, 'w');
        fwrite($fp, $content);
        fclose($fp);
    }

}

?>